Name:		owncloud
Version:		4.0.8
Release:		1%{?dist}
Summary:		Private file sync and share server

# starting with oc 4.5 add LGPLv3 license for apps/files_svgedit

License:		AGPLv3 and MIT
URL:		http://owncloud.org
Source0:		http://owncloud.org/releases/%{name}-%{version}.tar.bz2
Source1:		%{name}-httpd.conf
# very basic
Source2:		%{name}-logrotate.conf

Patch0:		%{name}-config.patch
# triggers selinux avc, write access on config/config.php is sufficient
Patch1:		%{name}-disable-config-dir-access-check.patch
# fix includes
Patch10:		%{name}-unbundle-blowfish.patch
Patch11:		%{name}-unbundle-phpmailer.patch
Patch12:		%{name}-unbundle-phptar.patch

BuildArch:	noarch

Requires:	%{name}-webserver = %{version}-%{release}
Requires:	%{name}-database = %{version}-%{release}

# PHP lib dependencies
Requires:	php-gd php-mbstring php-posix php-xml php-getid3
# PHP PEAR dependencies
Requires:	php-pear-Crypt-Blowfish
Requires:	php-pear-MDB2-Schema php-pear-Net-Curl php-pear-XML-Parser
# SabreDAV
Requires:	php-sabredav-Sabre_CalDAV php-sabredav-Sabre_CardDAV
# PHPMailer
Requires:	php-PHPMailer
# logrotate
Requires:	rsyslog
# dropped in the next release - not worth unbundling it
# php-When

# Bundled 3rdparty libs missing in Fedora
## JS (mainly jQuery plugins)
# https://github.com/harvesthq/chosen/
# http://fgelinas.com/code/timepicker
# http://arshaw.com/fullcalendar/


%description
ownCloud Server provides you a private file sync and share cloud. Host this
server to easily sync business or private documents across all your devices, and
share those documents with other users of your ownCloud server on their devices.


%package httpd
Summary:		Httpd integration for owncloud

Provides:	%{name}-webserver = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

# PHP dependencies
Requires:	php

%description httpd
%{summary}


# imagine something like %%package nginx here


%package mysql
Summary:		Virtual package providing MySQL dependencies for %{name}

Provides:	%{name}-database = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

Requires:	php-pear-MDB2-Driver-mysqli

%description mysql
%{summary}


%package postgresql
Summary:		Virtual package providing PostgreSQL dependencies for %{name}

Provides:	%{name}-database = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

Requires:	php-pear-MDB2-Driver-pgsql

%description postgresql
%{summary}


%package sqlite
Summary:		Virtual package providing Sqlite dependencies for %{name}

Provides:	%{name}-database = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

Requires:	php-pear-MDB2-Driver-sqlite

%description sqlite
%{summary}


%prep
%setup -q -n %{name}
%patch0
%patch1
%patch10
%patch11
%patch12

# Strip bundled libraries
rm -rf 3rdparty/{Archive,Console,Crypt_Blowfish,OS,MDB2,PEAR,Sabre,XML,simpletest,getid3}
rm -f 3rdparty/{MDB2,PEAR,Sabre.includes,System,class.phpmailer,class.smtp}.php

# clean up content
rm -rf apps/files_odfviewer/src
rm -f apps/files_texteditor/js/aceeditor/mode-text.js
rm -f apps/files_texteditor/js/aceeditor/mode-text-uncompressed.js
rm -f l10n/{l10n.pl,init.sh}


%build
# Nothing to build


%install
install -dm 755 %{buildroot}%{_datadir}/%{name}

# create owncloud datadir
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/data
# create owncloud sysconfdir
mkdir -p %{buildroot}%{_sysconfdir}/%{name}

# copy remaining content
cp -a apps	%{buildroot}%{_localstatedir}/lib/%{name}
cp -a core	%{buildroot}%{_datadir}/%{name}
cp -a files	%{buildroot}%{_datadir}/%{name}
cp -a l10n	%{buildroot}%{_datadir}/%{name}
cp -a lib	%{buildroot}%{_datadir}/%{name}
cp -a ocs	%{buildroot}%{_datadir}/%{name}
cp -a search	%{buildroot}%{_datadir}/%{name}
cp -a settings	%{buildroot}%{_datadir}/%{name}
cp -a themes	%{buildroot}%{_datadir}/%{name}
cp -a 3rdparty	%{buildroot}%{_datadir}/%{name}
install -pm 644 {index,public,remote,status,webapps}.php	%{buildroot}%{_datadir}/%{name}
install -pm 644 db_structure.xml	%{buildroot}%{_datadir}/%{name}
install -pm 644 config/config.sample.php %{buildroot}%{_sysconfdir}/%{name}/config.sample.php
install -pm 644 config/config.sample.php %{buildroot}%{_sysconfdir}/%{name}/config.php

# symlink config dir
ln -sf %{_sysconfdir}/%{name} %{buildroot}%{_datadir}/%{name}/config
# symlink apps dir - must be writable for the builtin app store
ln -sf %{_localstatedir}/lib/%{name}/apps %{buildroot}%{_datadir}/%{name}/apps

# httpd config
install -Dpm 644 %{SOURCE1} \
    %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

# logging
mkdir -p %{buildroot}%{_localstatedir}/log
touch %{buildroot}%{_localstatedir}/log/owncloud.log

install -Dpm 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}


%post httpd
/usr/bin/systemctl reload httpd.service > /dev/null 2>&1 || :

%postun httpd
if [ $1 -eq 0 ]; then
  /usr/bin/systemctl reload httpd.service > /dev/null 2>&1 || :
fi


%files
%doc AUTHORS COPYING-AGPL COPYING-README README

%dir %attr(-,apache,apache) %{_sysconfdir}/%{name}
%config(noreplace) %attr(0600,apache,apache) %{_sysconfdir}/%{name}/config.php
%config %attr(-,apache,apache) %{_sysconfdir}/%{name}/config.sample.php
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}

%{_datadir}/%{name}
%dir %attr(0755,apache,apache) %{_localstatedir}/lib/%{name}
# user data must not be world readable
%dir %attr(0750,apache,apache) %{_localstatedir}/lib/%{name}/data
%attr(-,apache,apache) %{_localstatedir}/lib/%{name}/apps

%ghost %{_localstatedir}/log/owncloud.log


%files httpd
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf


%files mysql
%files postgresql
%files sqlite


%changelog
* Thu Oct 18 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-1
- owncloud-4.0.8

* Fri Oct 12 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-5
- unbundle php-getid3
- remove conf dir access check

* Tue Oct 02 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-4
- require rsyslog
- switched log type back to 'owncloud'

* Sun Sep 23 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-3
- unbundled Archive/Tar.php, Guess.php, phpmailer
- created virtual packages for supported databases
- added logrotate script

* Thu Sep 20 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-2
- moved httpd files and sciptlets into own subpackage
- redirected log output to /var/log/owncloud.log
- deleted unecessary files

* Wed Sep 19 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-1
- updated to version 4.0.7

* Fri Apr 06 2012 Felix Kaechele <heffer@fedoraproject.org> - 3.0.1-1
- initial package

